package controllers

import (
	"AIOTCOER/lib"
	"AIOTCOER/models/Product"
	beego "github.com/beego/beego/v2/server/web"
)

type ProductProtController struct {
	beego.Controller
}

func (c *ProductProtController) ProductLangList() {

	ProductProt_r, Total := Product.ProductLangLists()

	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!", Data: lib.C_Page(ProductProt_r, 0, 0, Total)}
	c.ServeJSON()
	return
}

func (c *ProductProtController) Update() {
	T_uuid := lib.Take_one(c.Ctx.GetCookie("T_uuid"), c.GetString("T_uuid"))

	ProductProtr := Product.ProductProt{}
	c.ParseForm(&ProductProtr)

	if ProductProtr.Id == 0 {
		ProductProtr.Id,_ = ProductProtr.Add()
	}

	if !ProductProtr.Read() {
		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_ProductID E!"}
		c.ServeJSON()
		return
	}

	// 验证 TOKEY
	if ProductProtr.T_uuid != T_uuid {
		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
		c.ServeJSON()
		return
	}
	c.ParseForm(&ProductProtr)
	if !ProductProtr.Update("T_lang", "T_analysis", "T_text", "T_describe") {
		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "E!"}
		c.ServeJSON()
		return
	}

	lib.DownloadSo(ProductProtr.T_analysis) // 下载SO 文件

	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!",Data: ProductProtr}
	c.ServeJSON()
	return
}



func (c *ProductProtController) Get() {
	ProductProt := Product.ProductProt{}
	c.ParseForm(&ProductProt)
	T_uuid := lib.Take_one(c.Ctx.GetCookie("T_uuid"), c.GetString("T_uuid"))

	if !ProductProt.Read() {
		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "ID E!"}
		c.ServeJSON()
		return
	}

	// 验证 TOKEY
	if ProductProt.T_uuid != T_uuid {
		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
		c.ServeJSON()
		return
	}

	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!", Data: ProductProt}
	c.ServeJSON()
	return
}

//func (c *ProductProtController) List() {
//	PageIndex, _ := c.GetInt("PageIndex", 0)
//	PageSize, _ := c.GetInt("PageSize", 10)
//
//	ProductProtr := Product.ProductProt{}
//	c.ParseForm(&ProductProtr)
//
//	// 验证 TOKEY
//	if c.Ctx.Input.Host() != "127.0.0.1" {
//		if len(ProductProtr.T_uuid) != 8 {
//			c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
//			c.ServeJSON()
//			return
//		}
//	}
//
//	ProductProt_r, Total := ProductProtr.Lists(PageIndex, PageSize)
//
//	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!", Data: lib.C_Page(ProductProt_r, PageIndex, PageSize, Total)}
//	c.ServeJSON()
//	return
//}
//
//func (c *ProductProtController) Import() {
//	// 验证 TOKEY
//	T_uuid := lib.Take_one(c.Ctx.GetCookie("T_uuid"), c.GetString("T_uuid"))
//
//	if len(T_uuid) == 0 {
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
//		c.ServeJSON()
//		return
//	}
//
//	ProductProt_r := Product.ProductProt{}
//	c.ParseForm(&ProductProt_r)
//
//	if len(ProductProt_r.T_uuid) != 8 {
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
//		c.ServeJSON()
//		return
//	}
//
//	// 获取上传的zip文件
//	zipFile, _, err := c.GetFile("sozip")
//	if err != nil {
//		logs.Println("Error getting zip file:", err)
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "没有找到 sozip !"}
//		c.ServeJSON()
//		return
//	}
//	defer zipFile.Close()
//
//	// 创建一个临时文件来保存上传的zip文件
//	tempFile, err := os.Create(conf.Analysis_Dir + "temp.zip")
//	if err != nil {
//		logs.Println("Error creating temp file:", err)
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "临时文件 无法创建 !"}
//		c.ServeJSON()
//		return
//	}
//
//	// 将上传的zip文件内容复制到临时文件中
//	_, err = io.Copy(tempFile, zipFile)
//	if err != nil {
//		logs.Println("Error copying zip file to temp file:", err)
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "Copy!"}
//		c.ServeJSON()
//		return
//	}
//	tempFile.Close()
//
//	// 打开临时文件x
//	zipReader, err := zip.OpenReader(conf.Analysis_Dir + "temp.zip")
//	if err != nil {
//		logs.Println("Error opening temp file:", err)
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: err.Error()}
//		c.ServeJSON()
//		return
//	}
//	defer zipReader.Close()
//
//	// 解压文件
//	for _, file := range zipReader.File {
//		logs.Println("file.Name:", file.Name)
//
//		if file.Name == "ProductProt.json" {
//			// 打开文件
//			rc, err := file.Open()
//			if err != nil {
//				c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "file.Open!"}
//				c.ServeJSON()
//				return
//			}
//
//			defer rc.Close()
//			var contents strings.Builder
//			_, err = io.Copy(&contents, rc)
//			if err != nil {
//				c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "file.Open!"}
//				c.ServeJSON()
//				return
//			}
//			logs.Println("contents:", contents.String())
//
//			// 处理JSON文件
//			err = json.Unmarshal([]byte(contents.String()), &ProductProt_r)
//
//			// 处理jsonData，例如打印到控制台
//			logs.Println("jsonData:", ProductProt_r)
//		} else {
//			// 检查文件是否存在
//			if _, err := os.Stat(conf.Analysis_Dir + file.Name); !os.IsNotExist(err) {
//				logs.Println("文件已经存在:", conf.Analysis_Dir+file.Name)
//				continue
//			}
//			// 打开zip文件中的文件
//			zippedFile, err := file.Open()
//			if err != nil {
//				logs.Println("Error opening zipped file:", err)
//				c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "opening zipped file!"}
//				c.ServeJSON()
//				return
//			}
//			defer zippedFile.Close()
//
//			// 创建一个新文件来保存解压后的文件
//			newFile, err := os.Create(conf.Analysis_Dir + file.Name)
//			if err != nil {
//				logs.Println("Error creating new file:", err)
//				c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "Error creating new file!"}
//				c.ServeJSON()
//				return
//			}
//			defer newFile.Close()
//
//			// 将解压后的文件内容复制到新文件中
//			_, err = io.Copy(newFile, zippedFile)
//			if err != nil {
//				logs.Println("Error copying zipped file to new file:", err)
//				c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "io.Copy!"}
//				c.ServeJSON()
//				return
//			}
//		}
//
//	}
//
//	ProductProt_r.Id = 0
//	ProductProt_r.T_uuid = T_uuid
//	ProductProt_r.Add()
//
//	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!", Data: ProductProt_r}
//	c.ServeJSON()
//	return
//}
//
//func (c *ProductProtController) Delete() {
//	ProductProtr := Product.ProductProt{}
//	T_uuid := lib.Take_one(c.Ctx.GetCookie("T_uuid"), c.GetString("T_uuid"))
//
//	c.ParseForm(&ProductProtr)
//	if !ProductProtr.Read() {
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "ID E!"}
//		c.ServeJSON()
//		return
//	}
//
//	// 验证 TOKEY
//	if ProductProtr.T_uuid != T_uuid {
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "T_uuid!"}
//		c.ServeJSON()
//		return
//	}
//	if !ProductProtr.Delete() {
//		c.Data["json"] = lib.JSONR{Code: lib.Error, Msg: "E!"}
//		c.ServeJSON()
//		return
//	}
//
//	c.Data["json"] = lib.JSONR{Code: lib.Success, Msg: "ok!"}
//	c.ServeJSON()
//	return
//}
