package Product

import (
	"plugin"
	"sort"
)

// 网关
type ProductMode struct {
	Id         int    `json:"Id"`
	T_name     string `json:"T_name"`     // 协议名称  Mqtt
	T_connect  string `json:"T_connect"`  //接入地址    bj-3-mqtt.iot-api.com:1883
	T_describe string `json:"T_describe"` // 描述内容
	T_state    int    `json:"T_state"`    //状态  0停用  1 开启
	T_file     string `json:"-"`          //文件地址
	T_log      string `json:"T_log"`      //文件地址

	T_Config_map map[string]map[string]string `json:"T_Config_map"` //接入端口   8888
	T_Plugin     *plugin.Plugin               `json:"-"`            //状态
}

var ProductModeMap map[int]*ProductMode

func init() {
	ProductModeMap = make(map[int]*ProductMode)
}

// 获取列表
func ProductModeLists() (r []ProductMode, Total int64) {
	var ProductModeList = []ProductMode{}

	for _, v := range ProductModeMap {
		ProductModeList = append(ProductModeList, ProductMode{Id: v.Id, T_name: v.T_name, T_connect: v.T_connect, T_describe: v.T_describe, T_state: v.T_state, T_Config_map: v.T_Config_map, T_log: v.T_log})
	}
	// 对切片进行排序
	sort.Slice(ProductModeList, func(i, j int) bool {
		return ProductModeList[i].Id < ProductModeList[j].Id
	})
	return ProductModeList, int64(len(ProductModeList))
}

/*

1:HTTP
2:TCP
3:MQTT
10:CtwingHTTP

*/
