package routers

import (
	"AIOTCOER/controllers"
	beego "github.com/beego/beego/v2/server/web"
)

func init() {
	prefix := "/Product"

	// 产品类型
	//beego.Router(prefix+"/ProductType/Add", &controllers.ProductTypeController{}, "*:Add")       //
	beego.Router(prefix+"Type/Get", &controllers.ProductTypeController{}, "*:Get")       //
	beego.Router(prefix+"Type/List", &controllers.ProductTypeController{}, "*:List")     //
	beego.Router(prefix+"Type/Update", &controllers.ProductTypeController{}, "*:Update") //
	beego.Router(prefix+"Type/Delete", &controllers.ProductTypeController{}, "*:Delete") //
	// 统计流量
	beego.Router(prefix+"Type/FlowCount", &controllers.StatisticalDataController{}, "*:FlowCountList") // *全部；  get,post:



	// 接入网关
	beego.Router(prefix+"Mode/Import", &controllers.ProductModeController{}, "*:Import")         //
	beego.Router(prefix+"Mode/List", &controllers.ProductModeController{}, "*:ProductModeLists") //
	beego.Router(prefix+"Mode/Updata", &controllers.ProductModeController{}, "*:Updata")         //
	beego.Router(prefix+"Lang/List", &controllers.ProductProtController{}, "*:ProductLangList")  //


	// 产品OTA
	//----------- 配置图片
	beego.Router(prefix+"OTA/FileToken", &controllers.UpFileController{}, "*:UpFileToken") // *全部；  get,post:
	beego.Router(prefix+"OTA/Add", &controllers.ProductOTAController{}, "*:Add")       //
	beego.Router(prefix+"OTA/Get", &controllers.ProductOTAController{}, "*:Get")       //
	beego.Router(prefix+"OTA/List", &controllers.ProductOTAController{}, "*:List")     //
	beego.Router(prefix+"OTA/Delete", &controllers.ProductOTAController{}, "*:Delete") //


	beego.Router("/RunTime", &controllers.SystemController{}, "*:RunTime") //
	beego.Router("/SystemConfig", &controllers.SystemController{}, "*:SystemConfig") //


}
